Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.network
Class QHttp

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QObject
                  com.trolltech.qt.network.QHttp

All Implemented Interfaces:
  QtJambiInterface

    public class QHttp

extends QObject

The `QHttp` class provides an implementation of the HTTP protocol.

This class provides a direct interface to HTTP that allows you to have more control over the requests and that allows you to access the response header fields.

The class works asynchronously, so there are no blocking functions. If an operation cannot be executed immediately, the function will still return straight away and the operation will be scheduled for later execution. The results of scheduled operations are reported via signals. This approach depends on the event loop being in operation.

The operations that can be scheduled (they are called "requests" in the rest of the documentation) are the following: setHost(), `get`, `post`, `head` and `request`.

All of these requests return a unique identifier that allows you to keep track of the request that is currently executed. When the execution of a request starts, the `requestStarted` signal with the identifier is emitted and when the request is finished, the `requestFinished` signal is emitted with the identifier and a bool that indicates if the request finished with an error.

To make an HTTP request you must set up suitable HTTP headers. The following example demonstrates, how to request the main HTML page from the Trolltech home page (i.e. the URL `http://www.trolltech.com/index.html`):

        QHttpRequestHeader header("GET", "/index.html");
        header.setValue("Host", "www.trolltech.com");
        http->setHost("www.trolltech.com");
        http->request(header);

For the common HTTP requests `GET`, `POST` and `HEAD`, `QHttp` provides the convenience functions `get`, `post` and `head`. They already use a reasonable header and if you don't have to set special header fields, they are easier to use. The above example can also be written as:

        http->setHost("www.trolltech.com"); // id == 1
        http->get("/index.html");           // id == 2

For this example the following sequence of signals is emitted (with small variations, depending on network traffic, etc.):

        requestStarted(1)
        requestFinished(1, false)

        requestStarted(2)
        stateChanged(Connecting)
        stateChanged(Sending)
        dataSendProgress(77, 77)
        stateChanged(Reading)
        responseHeaderReceived(responseheader)
        dataReadProgress(5388, 0)
        readyRead(responseheader)
        dataReadProgress(18300, 0)
        readyRead(responseheader)
        stateChanged(Connected)
        requestFinished(2, false)

        done(false)

        stateChanged(Closing)
        stateChanged(Unconnected)

The `dataSendProgress` and `dataReadProgress` signals in the above example are useful if you want to show a progress bar to inform the user about the progress of the download. The second argument is the total size of data. In certain cases it is not possible to know the total amount in advance, in which case the second argument is 0. (If you connect to a `QProgressBar` a total of 0 results in a busy indicator.)

When the response header is read, it is reported with the `responseHeaderReceived` signal.

The `readyRead` signal tells you that there is data ready to be read. The amount of data can then be queried with the `bytesAvailable` function and it can be read with the read() or `readAll` functions.

If an error occurs during the execution of one of the commands in a sequence of commands, all the pending commands (i.e. scheduled, but not yet executed commands) are cleared and no signals are emitted for them.

For example, if you have the following sequence of requests

        http->setHost("www.foo.bar");       // id == 1
        http->get("/index.html");           // id == 2
        http->post("register.html", data);  // id == 3

and the `get` request fails because the host lookup fails, then the `post` request is never executed and the signals would look like this:

        requestStarted(1)
        requestFinished(1, false)

        requestStarted(2)
        stateChanged(HostLookup)
        requestFinished(2, true)

        done(true)

        stateChanged(Unconnected)

You can then get details about the error with the `error` and `errorString` functions. Note that only unexpected behavior, like network failure is considered as an error. If the server response contains an error status, like a 404 response, this is reported as a normal response case. So you should always check the status code of the response header.

The functions `currentId` and `currentRequest` provide more information about the currently executing request.

The functions `hasPendingRequests` and `clearPendingRequests` allow you to query and clear the list of pending requests.

See Also:
  `QFtp`, HTTP Example, `Example`

Nested Class Summary
`static class` | `QHttp.ConnectionMode` This enum is used to specify the mode of connection to use.
`static class` | `QHttp.Error` This enum identifies the error that occurred.
`static class` | `QHttp.State` This enum is used to specify the state the client is in.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Field Summary
`QSignalEmitter.Signal3<java.lang.String,java.lang.Integer,QAuthenticator>` | `authenticationRequired`
`QSignalEmitter.Signal2<java.lang.Integer,java.lang.Integer>` | `dataReadProgress` This signal is emitted when this object reads data from a HTTP server to indicate the current progress of the download.
`QSignalEmitter.Signal2<java.lang.Integer,java.lang.Integer>` | `dataSendProgress` This signal is emitted when this object sends data to a HTTP server to inform it about the progress of the upload.
`QSignalEmitter.Signal1<java.lang.Boolean>` | `done` This signal is emitted when the last pending request has finished; (it is emitted after the last request's `requestFinished` signal).
`QSignalEmitter.Signal2<QNetworkProxy,QAuthenticator>` | `proxyAuthenticationRequired`
`QSignalEmitter.Signal1<QHttpResponseHeader>` | `readyRead` This signal is emitted when there is new response data to read.
`QSignalEmitter.Signal2<java.lang.Integer,java.lang.Boolean>` | `requestFinished` This signal is emitted when processing the request identified by `arg__1` has finished.
`QSignalEmitter.Signal1<java.lang.Integer>` | `requestStarted` This signal is emitted when processing the request identified by `arg__1` starts.
`QSignalEmitter.Signal1<QHttpResponseHeader>` | `responseHeaderReceived` This signal is emitted when the HTTP header of a server response is available.
`QSignalEmitter.Signal1<java.lang.Integer>` | `stateChanged` This signal is emitted when the state of the `QHttp` object changes.

Constructor Summary
`QHttp()` Equivalent to `QHttp`(0).
`QHttp(QObject parent)` Constructs a `QHttp` object.
`QHttp(java.lang.String hostname, int port)` This is an overloaded constructor provided for convenince.
`QHttp(java.lang.String hostname, int port, QObject parent)` This is an overloaded constructor provided for convenince.
`QHttp(java.lang.String hostname, QHttp.ConnectionMode mode, int port)` This is an overloaded constructor provided for convenince.
`QHttp(java.lang.String hostname, QHttp.ConnectionMode mode, int port, QObject parent)` Constructs a QHttp object.

Method Summary
`void` | `abort()` Aborts the current request and deletes all scheduled requests.
`long` | `bytesAvailable()` Returns the number of bytes that can be read from the response content at the moment.
`void` | `clearPendingRequests()` Deletes all pending requests from the list of scheduled requests.
`int` | `close()` Closes the connection; this is useful if you have a keep-alive connection and want to close it.
`QIODevice` | `currentDestinationDevice()` Returns the `QIODevice` pointer that is used as to store the data of the HTTP request being executed.
`int` | `currentId()` Returns the identifier of the HTTP request being executed or 0 if there is no request being executed (i.e. they've all finished).
`QHttpRequestHeader` | `currentRequest()` Returns the request header of the HTTP request being executed.
`QIODevice` | `currentSourceDevice()` Returns the `QIODevice` pointer that is used as the data source of the HTTP request being executed.
`QHttp.Error` | `error()` Returns the last error that occurred.
`java.lang.String` | `errorString()` Returns a human-readable description of the last error that occurred.
`static QHttp` | `fromNativePointer(QNativePointer nativePointer)` This function returns the QHttp instance pointed to by nativePointer
`int` | `get(java.lang.String path)` Equivalent to get(`path`, 0).
`int` | `get(java.lang.String path, QIODevice to)` Sends a get request for `path` to the server set by setHost() or as specified in the constructor.
`boolean` | `hasPendingRequests()` Returns true if there are any requests scheduled that have not yet been executed; otherwise returns false.
`int` | `head(java.lang.String path)` Sends a header request for `path` to the server set by setHost() or as specified in the constructor.
`void` | `ignoreSslErrors()` Tells the QSslSocket used for the Http connection to ignore the errors reported in the sslErrors() signal.
`QHttpResponseHeader` | `lastResponse()` Returns the received response header of the most recently finished HTTP request.
`int` | `post(java.lang.String path, QByteArray data)` Equivalent to post(`path`, `data`, 0).
`int` | `post(java.lang.String path, QByteArray data, QIODevice to)` `data` is used as the content data of the HTTP request.
`int` | `post(java.lang.String path, QIODevice data)` Equivalent to post(`path`, `data`, 0).
`int` | `post(java.lang.String path, QIODevice data, QIODevice to)` Sends a post request for `path` to the server set by setHost() or as specified in the constructor.
`int` | `read(byte[] data)` Reads from the response content into `data` and returns the number of bytes read.
`QByteArray` | `readAll()` Reads all the bytes from the response content and returns them.
`int` | `request(QHttpRequestHeader header)` Equivalent to request(`header`, 0, 0).
`int` | `request(QHttpRequestHeader header, QByteArray data)` Equivalent to request(`header`, `data`, 0).
`int` | `request(QHttpRequestHeader header, QByteArray data, QIODevice to)` `data` is used as the content data of the HTTP request.
`int` | `request(QHttpRequestHeader header, QIODevice device)` Equivalent to request(`header`, `device`, 0).
`int` | `request(QHttpRequestHeader header, QIODevice device, QIODevice to)` Sends a request to the server set by setHost() or as specified in the constructor.
`int` | `setHost(java.lang.String hostname, int port)` Sets the HTTP server that is used for requests to `hostname` on port `port`.
`int` | `setHost(java.lang.String hostname, QHttp.ConnectionMode mode, int port)` Sets the HTTP server that is used for requests to `hostname` on port `port using the connection mode `mode`.`
`int` | `setProxy(QNetworkProxy proxy)` Enables HTTP proxy support using the proxy settings from `proxy`.
`int` | `setProxy(java.lang.String host, int port)` Equivalent to `setProxy`(`host`, `port`, QString(), QString()).
`int` | `setProxy(java.lang.String host, int port, java.lang.String username)` Equivalent to `setProxy`(`host`, `port`, `username`, QString()).
`int` | `setProxy(java.lang.String host, int port, java.lang.String username, java.lang.String password)` Enables HTTP proxy support, using the proxy server `host` on port `port`.
`int` | `setSocket(QTcpSocket socket)` Replaces the internal `QTcpSocket` that `QHttp` uses with `socket`.
`int` | `setUser(java.lang.String username)` Equivalent to `setUser`(`username`, QString()).
`int` | `setUser(java.lang.String username, java.lang.String password)` This function sets the user name `username` and password `password` for web pages that require authentication.
`QHttp.State` | `state()` Returns the current state of the object.

Methods inherited from class com.trolltech.qt.core.QObject
`blockSignals, childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, property, removeEventFilter, setObjectName, setParent, setProperty, signalsBlocked, startTimer, thread, timerEvent`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`disconnect, disconnect, signalSender`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### dataReadProgress

    public final QSignalEmitter.Signal2<java.lang.Integer,java.lang.Integer> dataReadProgress

  This signal is emitted when this object reads data from a HTTP server to indicate the current progress of the download.

  `arg__1` is the amount of data that has already arrived and `arg__2` is the total amount of data. It is possible that the total amount of data that should be transferred cannot be determined, in which case `arg__2` is 0.(If you connect to a `QProgressBar`, the progress bar shows a busy indicator if the total is 0).

  Warning: `arg__1` and `arg__2` are not necessarily the size in bytes, since for large files these values might need to be "scaled" to avoid overflow.

  Compatible Slot Signatures:
    `void mySlot(int arg__1, int arg__2)`
    `void mySlot(int arg__1)`
    `void mySlot()`
  See Also:
    `dataSendProgress`, `get`, `post`, `request`, `QProgressBar`

### dataSendProgress

    public final QSignalEmitter.Signal2<java.lang.Integer,java.lang.Integer> dataSendProgress

  This signal is emitted when this object sends data to a HTTP server to inform it about the progress of the upload.

  `arg__1` is the amount of data that has already arrived and `arg__2` is the total amount of data. It is possible that the total amount of data that should be transferred cannot be determined, in which case `arg__2` is 0.(If you connect to a `QProgressBar`, the progress bar shows a busy indicator if the total is 0).

  Warning: `arg__1` and `arg__2` are not necessarily the size in bytes, since for large files these values might need to be "scaled" to avoid overflow.

  Compatible Slot Signatures:
    `void mySlot(int arg__1, int arg__2)`
    `void mySlot(int arg__1)`
    `void mySlot()`
  See Also:
    `dataReadProgress`, `post`, `request`, `QProgressBar`

### done

    public final QSignalEmitter.Signal1<java.lang.Boolean> done

  This signal is emitted when the last pending request has finished; (it is emitted after the last request's `requestFinished` signal). `arg__1` is true if an error occurred during the processing; otherwise `arg__1` is false.

  Compatible Slot Signatures:
    `void mySlot(boolean arg__1)`
    `void mySlot()`
  See Also:
    `requestFinished`, `error`, `errorString`

### readyRead

    public final QSignalEmitter.Signal1<QHttpResponseHeader> readyRead

  This signal is emitted when there is new response data to read.

  If you specified a device in the request where the data should be written to, then this signal is not emitted; instead the data is written directly to the device.

  The response header is passed in `resp`.

  You can read the data with the `readAll` or read() functions

  This signal is useful if you want to process the data in chunks as soon as it becomes available. If you are only interested in the complete data, just connect to the `requestFinished` signal and read the data then instead.

  Compatible Slot Signatures:
    `void mySlot(com.trolltech.qt.network.QHttpResponseHeader resp)`
    `void mySlot()`
  See Also:
    `get`, `post`, `request`, `readAll`, `read`, `bytesAvailable`

### requestFinished

    public final QSignalEmitter.Signal2<java.lang.Integer,java.lang.Boolean> requestFinished

  This signal is emitted when processing the request identified by `arg__1` has finished. `arg__2` is true if an error occurred during the processing; otherwise `arg__2` is false.

  Compatible Slot Signatures:
    `void mySlot(int arg__1, boolean arg__2)`
    `void mySlot(int arg__1)`
    `void mySlot()`
  See Also:
    `requestStarted`, `done`, `error`, `errorString`

### requestStarted

    public final QSignalEmitter.Signal1<java.lang.Integer> requestStarted

  This signal is emitted when processing the request identified by `arg__1` starts.

  Compatible Slot Signatures:
    `void mySlot(int arg__1)`
    `void mySlot()`
  See Also:
    `requestFinished`, `done`

### responseHeaderReceived

    public final QSignalEmitter.Signal1<QHttpResponseHeader> responseHeaderReceived

  This signal is emitted when the HTTP header of a server response is available. The header is passed in `resp`.

  Compatible Slot Signatures:
    `void mySlot(com.trolltech.qt.network.QHttpResponseHeader resp)`
    `void mySlot()`
  See Also:
    `get`, `post`, `head`, `request`, `readyRead`

### stateChanged

    public final QSignalEmitter.Signal1<java.lang.Integer> stateChanged

  This signal is emitted when the state of the `QHttp` object changes. The argument `arg__1` is the new state of the connection; it is one of the State values.

  This usually happens when a request is started, but it can also happen when the server closes the connection or when a call to `close` succeeded.

  Compatible Slot Signatures:
    `void mySlot(int arg__1)`
    `void mySlot()`
  See Also:
    `get`, `post`, `head`, `request`, `close`, `state`, State

### proxyAuthenticationRequired

    public QSignalEmitter.Signal2<QNetworkProxy,QAuthenticator> proxyAuthenticationRequired

### authenticationRequired

    public QSignalEmitter.Signal3<java.lang.String,java.lang.Integer,QAuthenticator> authenticationRequired

Constructor Detail

### QHttp

    public QHttp()

  Equivalent to `QHttp`(0).

### QHttp

    public QHttp(QObject parent)

  Constructs a `QHttp` object. The `parent` parameter is passed on to the `QObject` constructor.

### QHttp

    public QHttp(java.lang.String hostname,
                 int port)

  This is an overloaded constructor provided for convenince.

### QHttp

    public QHttp(java.lang.String hostname,
                 int port,
                 QObject parent)

  This is an overloaded constructor provided for convenince.

### QHttp

    public QHttp(java.lang.String hostname,
                 QHttp.ConnectionMode mode,
                 int port)

  This is an overloaded constructor provided for convenince.

### QHttp

    public QHttp(java.lang.String hostname,
                 QHttp.ConnectionMode mode,
                 int port,
                 QObject parent)

  Constructs a QHttp object. Subsequent requests are done by connecting to the server `hostName` on port `port` using the connection mode `mode`.

  If port is 0, it will use the default port for the `mode` used (80 for Http and 443 for Https).

  The `parent` parameter is passed on to the QObject constructor.

Method Detail

### abort

    public final void abort()

  Aborts the current request and deletes all scheduled requests.

  For the current request, the `requestFinished` signal with the `error` argument `true` is emitted. For all other requests that are affected by the `abort`, no signals are emitted.

  Since this slot also deletes the scheduled requests, there are no requests left and the `done` signal is emitted (with the `error` argument `true`).

  See Also:
    `clearPendingRequests`

### bytesAvailable

    public final long bytesAvailable()

  Returns the number of bytes that can be read from the response content at the moment.

  See Also:
    `get`, `post`, `request`, `readyRead`, `read`, `readAll`

### clearPendingRequests

    public final void clearPendingRequests()

  Deletes all pending requests from the list of scheduled requests. This does not affect the request that is being executed. If you want to stop this this as well, use `abort`.

  See Also:
    `hasPendingRequests`, `abort`

### close

    public final int close()

  Closes the connection; this is useful if you have a keep-alive connection and want to close it.

  For the requests issued with `get`, `post` and `head`, `QHttp` sets the connection to be keep-alive. You can also do this using the header you pass to the `request` function. `QHttp` only closes the connection to the HTTP server if the response header requires it to do so.

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by `requestStarted` and `requestFinished`.

  When the request is started the `requestStarted` signal is emitted. When it is finished the `requestFinished` signal is emitted.

  If you want to close the connection immediately, you have to use `abort` instead.

  See Also:
    `stateChanged`, `abort`, `requestStarted`, `requestFinished`, `done`

### currentDestinationDevice

    public final QIODevice currentDestinationDevice()

  Returns the `QIODevice` pointer that is used as to store the data of the HTTP request being executed. If there is no current request or if the request does not store the data to an IO device, this function returns 0.

  This function can be used to delete the `QIODevice` in the slot connected to the `requestFinished` signal.

  See Also:
    `currentSourceDevice`, `get`, `post`, `request`

### currentId

    public final int currentId()

  Returns the identifier of the HTTP request being executed or 0 if there is no request being executed (i.e. they've all finished).

  See Also:
    `currentRequest`

### currentRequest

    public final QHttpRequestHeader currentRequest()

  Returns the request header of the HTTP request being executed. If the request is one issued by setHost() or `close`, it returns an invalid request header, i.e. QHttpRequestHeader::isValid() returns false.

  See Also:
    `currentId`

### currentSourceDevice

    public final QIODevice currentSourceDevice()

  Returns the `QIODevice` pointer that is used as the data source of the HTTP request being executed. If there is no current request or if the request does not use an IO device as the data source, this function returns 0.

  This function can be used to delete the `QIODevice` in the slot connected to the `requestFinished` signal.

  See Also:
    `currentDestinationDevice`, `post`, `request`

### error

    public final QHttp.Error error()

  Returns the last error that occurred. This is useful to find out what happened when receiving a `requestFinished` or a `done` signal with the `error` argument `true`.

  If you start a new request, the error status is reset to `NoError`.

### errorString

    public final java.lang.String errorString()

  Returns a human-readable description of the last error that occurred. This is useful to present a error message to the user when receiving a `requestFinished` or a `done` signal with the `error` argument `true`.

### get

    public final int get(java.lang.String path)

  Equivalent to get(`path`, 0).

### get

    public final int get(java.lang.String path,
                         QIODevice to)

  Sends a get request for `path` to the server set by setHost() or as specified in the constructor.

  `path` must be an absolute path like `/index.html` or an absolute URI like `http://www.trolltech.com/index.html`.

  If the IO device `to` is 0 the `readyRead` signal is emitted every time new content data is available to read.

  If the IO device `to` is not 0, the content data of the response is written directly to the device. Make sure that the `to` pointer is valid for the duration of the operation (it is safe to delete it when the `requestFinished` signal is emitted).

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by `requestStarted` and `requestFinished`.

  When the request is started the `requestStarted` signal is emitted. When it is finished the `requestFinished` signal is emitted.

  See Also:
    `setHost`, `post`, `head`, `request`, `requestStarted`, `requestFinished`, `done`

### hasPendingRequests

    public final boolean hasPendingRequests()

  Returns true if there are any requests scheduled that have not yet been executed; otherwise returns false.

  The request that is being executed is not considered as a scheduled request.

  See Also:
    `clearPendingRequests`, `currentId`, `currentRequest`

### head

    public final int head(java.lang.String path)

  Sends a header request for `path` to the server set by setHost() or as specified in the constructor.

  `path` must be an absolute path like `/index.html` or an absolute URI like `http://www.trolltech.com/index.html`.

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by `requestStarted` and `requestFinished`.

  When the request is started the `requestStarted` signal is emitted. When it is finished the `requestFinished` signal is emitted.

  See Also:
    `setHost`, `get`, `post`, `request`, `requestStarted`, `requestFinished`, `done`

### ignoreSslErrors

    public final void ignoreSslErrors()

  Tells the QSslSocket used for the Http connection to ignore the errors reported in the sslErrors() signal.

  Note that this function must be called from within a slot connected to the sslErrors() signal to have any effect.

  See Also:
    `QSslSocket`, `QSslSocket::sslErrors`

### lastResponse

    public final QHttpResponseHeader lastResponse()

  Returns the received response header of the most recently finished HTTP request. If no response has yet been received QHttpResponseHeader::isValid() will return false.

  See Also:
    `currentRequest`

### post

    public final int post(java.lang.String path,
                          QIODevice data)

  Equivalent to post(`path`, `data`, 0).

### post

    public final int post(java.lang.String path,
                          QIODevice data,
                          QIODevice to)

  Sends a post request for `path` to the server set by setHost() or as specified in the constructor.

  `path` must be an absolute path like `/index.html` or an absolute URI like `http://www.trolltech.com/index.html`.

  The incoming data comes via the `data` IO device.

  If the IO device `to` is 0 the `readyRead` signal is emitted every time new content data is available to read.

  If the IO device `to` is not 0, the content data of the response is written directly to the device. Make sure that the `to` pointer is valid for the duration of the operation (it is safe to delete it when the `requestFinished` signal is emitted).

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by `requestStarted` and `requestFinished`.

  When the request is started the `requestStarted` signal is emitted. When it is finished the `requestFinished` signal is emitted.

  See Also:
    `setHost`, `get`, `head`, `request`, `requestStarted`, `requestFinished`, `done`

### post

    public final int post(java.lang.String path,
                          QByteArray data)

  Equivalent to post(`path`, `data`, 0).

### post

    public final int post(java.lang.String path,
                          QByteArray data,
                          QIODevice to)

  `data` is used as the content data of the HTTP request.

### readAll

    public final QByteArray readAll()

  Reads all the bytes from the response content and returns them.

  See Also:
    `get`, `post`, `request`, `readyRead`, `bytesAvailable`, `read`

### request

    public final int request(QHttpRequestHeader header,
                             QIODevice device)

  Equivalent to request(`header`, `device`, 0).

### request

    public final int request(QHttpRequestHeader header)

  Equivalent to request(`header`, 0, 0).

### request

    public final int request(QHttpRequestHeader header,
                             QIODevice device,
                             QIODevice to)

  Sends a request to the server set by setHost() or as specified in the constructor. Uses the `header` as the HTTP request header. You are responsible for setting up a header that is appropriate for your request.

  The incoming data comes via the `device` IO device.

  If the IO device `to` is 0 the `readyRead` signal is emitted every time new content data is available to read.

  If the IO device `to` is not 0, the content data of the response is written directly to the device. Make sure that the `to` pointer is valid for the duration of the operation (it is safe to delete it when the `requestFinished` signal is emitted).

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by `requestStarted` and `requestFinished`.

  When the request is started the `requestStarted` signal is emitted. When it is finished the `requestFinished` signal is emitted.

  See Also:
    `setHost`, `get`, `post`, `head`, `requestStarted`, `requestFinished`, `done`

### request

    public final int request(QHttpRequestHeader header,
                             QByteArray data)

  Equivalent to request(`header`, `data`, 0).

### request

    public final int request(QHttpRequestHeader header,
                             QByteArray data,
                             QIODevice to)

  `data` is used as the content data of the HTTP request.

### setProxy

    public final int setProxy(QNetworkProxy proxy)

  Enables HTTP proxy support using the proxy settings from `proxy`.

### setProxy

    public final int setProxy(java.lang.String host,
                              int port,
                              java.lang.String username)

  Equivalent to `setProxy`(`host`, `port`, `username`, QString()).

### setProxy

    public final int setProxy(java.lang.String host,
                              int port)

  Equivalent to `setProxy`(`host`, `port`, QString(), QString()).

### setProxy

    public final int setProxy(java.lang.String host,
                              int port,
                              java.lang.String username,
                              java.lang.String password)

  Enables HTTP proxy support, using the proxy server `host` on port `port`. `username` and `password` can be provided if the proxy server requires authentication.

  Example:

          void Ticker::getTicks()
          {
            http = new QHttp(this);
            connect(http, SIGNAL(done(bool)), this, SLOT(showPage()));
            http->setProxy("proxy.example.com", 3128);
            http->setHost("ticker.example.com");
            http->get("/ticks.asp");
          }

          void Ticker::showPage()
          {
            display(http->readAll());
          }

  `QHttp` supports non-transparent web proxy servers only, such as the Squid Web proxy cache server (from http://www.squid.org/). For transparent proxying, such as SOCKS5, use `QNetworkProxy` instead.

  See Also:
    `QFtp::setProxy`

### setSocket

    public final int setSocket(QTcpSocket socket)

  Replaces the internal `QTcpSocket` that `QHttp` uses with `socket`. This is useful if you want to use your own custom `QTcpSocket` subclass instead of the plain `QTcpSocket` that `QHttp` uses by default. `QHttp` does not take ownership of the socket, and will not delete `socket` when destroyed.

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by `requestStarted` and `requestFinished`.

  When the request is started the `requestStarted` signal is emitted. When it is finished the `requestFinished` signal is emitted.

  Note: If `QHttp` is used in a non-GUI thread that runs its own event loop, you must move `socket` to that thread before calling `setSocket`.

  See Also:
    `QObject::moveToThread`, Thread Support in Qt

### setUser

    public final int setUser(java.lang.String username)

  Equivalent to `setUser`(`username`, QString()).

### setUser

    public final int setUser(java.lang.String username,
                             java.lang.String password)

  This function sets the user name `username` and password `password` for web pages that require authentication.

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by `requestStarted` and `requestFinished`.

  When the request is started the `requestStarted` signal is emitted. When it is finished the `requestFinished` signal is emitted.

### state

    public final QHttp.State state()

  Returns the current state of the object. When the state changes, the `stateChanged` signal is emitted.

  See Also:
    State, `stateChanged`

### fromNativePointer

    public static QHttp fromNativePointer(QNativePointer nativePointer)

  This function returns the QHttp instance pointed to by nativePointer

  Parameters:
    `nativePointer` - the QNativePointer of which object should be returned.

### read

    public final int read(byte[] data)

  Reads from the response content into `data` and returns the number of bytes read. Returns -1 if an error occurred.

### setHost

    public final int setHost(java.lang.String hostname,
                             QHttp.ConnectionMode mode,
                             int port)

  Sets the HTTP server that is used for requests to `hostname` on port `port using the connection mode `mode`.

  If port is 0, it will use the default port for the `mode` used (80 for Http and 443 fopr Https).

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by requestStarted() and requestFinished().

  When the request is started the requestStarted() signal is emitted. When it is finished the requestFinished() signal is emitted.

  `

### setHost

    public final int setHost(java.lang.String hostname,
                             int port)

  Sets the HTTP server that is used for requests to `hostname` on port `port`.

  The function does not block and returns immediately. The request is scheduled, and its execution is performed asynchronously. The function returns a unique identifier which is passed by requestStarted() and requestFinished().

  When the request is started the requestStarted() signal is emitted. When it is finished the requestFinished() signal is emitted.

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD